# == Schema Information
#
# Table name: language_implementations
#
#  id          :integer          not null, primary key
#  name        :string(255)
#  language_id :integer
#  created_at  :datetime
#  updated_at  :datetime
#

class LanguageImplementation < ActiveRecord::Base

  belongs_to :language, dependent: :destroy, inverse_of: :language_implementations
  has_many :benchmark_results, inverse_of: :language_implementation

end
